; GreenMachine/theme.jl

(let*
  (
    (font-colors (list "black"
                       "white"))
    
    (close-image (list (make-image "close-inactive.png")
                       (make-image "close-active.png")))
    (max-image (list (make-image "max-inactive.png")
                     (make-image "max-active.png")))
    (min-image (list (make-image "min-inactive.png")
                     (make-image "min-active.png")))
    (top-left-image (list (make-image "top-left-inactive.png")
                          (make-image "top-left-active.png")))
    (top-left-shaded-image (list (make-image "top-left-inactive-shaded.png")
                                 (make-image "top-left-active-shaded.png")))
    (top-image (list (make-image "title-inactive.png")
                     (make-image "title-active.png")))
    (top-right-image (list (make-image "top-right-inactive.png")
                           (make-image "top-right-active.png")))
    (top-right-shaded-image (list (make-image "top-right-inactive-shaded.png")
                                  (make-image "top-right-active-shaded.png")))
    (top-right-transient-image (list (make-image "top-right-inactive-transient.png")
                                     (make-image "top-right-active-transient.png")))
    (top-right-transient-shaded-image (list (make-image "top-right-inactive-transient-shaded.png")
                                            (make-image "top-right-active-transient-shaded.png")))
    (bottom-left-image (make-image "bottom-left.png"))
    (bottom-image (make-image "bottom.png"))
    (bottom-right-image (make-image "bottom-right.png"))
    (left-image (make-image "left.png"))
    (right-image (make-image "right.png"))

    (frame `(
        ((background . ,top-left-image)
         (top-edge . -27)
         (left-edge . -7)
         (class . title))
        ((background . ,top-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (left-edge . 3)
         (right-edge . 51)
         (top-edge . -27)
         (class . title))
        ((background . ,top-right-image)
         (right-edge . -7)
         (top-edge . -27)
         (class . title))
        ((background . ,left-image)
         (left-edge . -7)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . left-border))
        ((background . ,right-image)
         (right-edge . -7)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . right-border))
        ((background . ,bottom-left-image)
         (left-edge . -7)
         (bottom-edge . -7)
         (class . bottom-left-corner))
        ((background . ,bottom-image)
         (left-edge . 0)
         (right-edge .0)
         (bottom-edge . -7)
         (class . bottom-border))
        ((background . ,bottom-right-image)
         (right-edge . -7)
         (bottom-edge . -7)
         (class . bottom-right-corner))
        
        ((background . ,close-image)
         (right-edge . -1)
         (top-edge . -23)
         (class . close-button))
        ((background . ,max-image)
         (right-edge . 15)
         (top-edge . -23)
         (class . maximize-button))
        ((background . ,min-image)
         (right-edge . 31)
         (top-edge . -23)
         (class . iconify-button))
      ))

    (shaped-frame `(
        ((background . ,top-left-shaded-image)
         (top-edge . -27)
         (left-edge . -7)
         (class . title))
        ((background . ,top-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (left-edge . 3)
         (right-edge . 51)
         (top-edge . -27)
         (class . title))
        ((background . ,top-right-shaded-image)
         (right-edge . -7)
         (top-edge . -27)
         (class . title))
        
        ((background . ,close-image)
         (right-edge . -1)
         (top-edge . -23)
         (class . close-button))
        ((background . ,max-image)
         (right-edge . 15)
         (top-edge . -23)
         (class . maximize-button))
        ((background . ,min-image)
         (right-edge . 31)
         (top-edge . -23)
         (class . iconify-button))
      ))

     (transient-frame `(
        ((background . ,top-left-image)
         (top-edge . -27)
         (left-edge . -7)
         (class . title))
        ((background . ,top-right-transient-image)
         (right-edge . -7)
         (top-edge . -27)
         (class . title))
        ((background . ,top-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (left-edge . 3)
         (right-edge . 16)
         (top-edge . -27)
         (class . title))
        ((background . ,left-image)
         (left-edge . -7)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . left-border))
        ((background . ,right-image)
         (right-edge . -7)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . right-border))
        ((background . ,bottom-left-image)
         (left-edge . -7)
         (bottom-edge . -7)
         (class . bottom-left-corner))
        ((background . ,bottom-image)
         (left-edge . 0)
         (right-edge .0)
         (bottom-edge . -7)
         (class . bottom-border))
        ((background . ,bottom-right-image)
         (right-edge . -7)
         (bottom-edge . -7)
         (class . bottom-right-corner))
        
        ((background . ,close-image)
         (right-edge . -1)
         (top-edge . -23)
         (class . close-button))
      ))

     (shaped-transient-frame `(
        ((background . ,top-left-shaded-image)
         (top-edge . -27)
         (left-edge . -7)
         (class . title))
        ((background . ,top-right-transient-shaded-image)
         (right-edge . -7)
         (top-edge . -27)
         (class . title))
        ((background . ,top-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (left-edge . 3)
         (right-edge . 16)
         (top-edge . -27)
         (class . title))

        
        ((background . ,close-image)
         (right-edge . -1)
         (top-edge . -23)
         (class . close-button))
      ))
   )
      
  (add-frame-style 'GreenMachine
    (lambda (w type)
      (cond 
            ((eq type 'transient) transient-frame)
            ((eq type 'shaped-transient) shaped-transient-frame)
            ((eq type 'shaped) shaped-frame)
            ((eq type 'unframed) nil-frame)
            (t frame))))            
)
